import cn.hutool.core.util.StrUtil;
import com.baomidou.dynamic.datasource.annotation.DSTransactional;
import com.ruoyi.common.core.domain.BaseIdPo;
import com.sd.SdApplication;
import com.sd.business.entity.bom.po.BomSpec;
import com.sd.business.entity.in.po.InOutStorageDetails;
import com.sd.business.entity.inventory.po.Inventory;
import com.sd.business.service.bom.BomSpecService;
import com.sd.business.service.in.InOutStorageDetailsService;
import com.sd.business.service.inventory.InventoryService;
import com.sd.business.service.warehouse.WarehouseService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@RunWith(SpringRunner.class)
@SpringBootTest(classes = SdApplication.class, webEnvironment = SpringBootTest.WebEnvironment.DEFINED_PORT)
public class C2_SyncInventoryTest {


    @Autowired
    private WarehouseService warehouseService;

    @Autowired
    private BomSpecService bomSpecService;

    @Autowired
    private InventoryService inventoryService;

    @Autowired
    private InOutStorageDetailsService inOutStorageDetailsService;

    /**
     * string修改库存
     */
    @DSTransactional
    @Test
    public void test() {

        String a = "204010400192 2075  \n" +
                "204010400195 1851  \n" +
                "204010400198 213      \n" +
                "204010400193 396   \n" +
                "204010400196 3617  \n" +
                "204010400199 322 \n" +
                "204010400201 890  \n" +
                "204010400205 1731  \n" +
                "204010400209 448\n" +
                "204010400250 299   \n" +
                "204010400200 431  \n" +
                "204010400212 338  \n" +
                "204010400211 712";

        List<List<String>> list = Arrays.stream(a.split("\n"))
                .map(item -> Arrays.stream(item.split(" ")).filter(StrUtil::isNotBlank).collect(Collectors.toList()))
                .collect(Collectors.toList());

        Map<String, Long> bomSpecMap = bomSpecService.mapKV(BomSpec::getCode, BaseIdPo::getId, null);


        for (List<String> data : list) {

            String code = data.get(0);
            String quantity = data.get(1);

            Long bomSpecId = bomSpecMap.get(code);
            if (bomSpecId == null) {
                System.err.println(code + " 为空");
            }

            boolean update = inventoryService.update(q -> q
                    .eq(Inventory::getBomSpecId, bomSpecId)
                    .eq(Inventory::getWarehouseId, 1684037244354052098L)
                    .eq(Inventory::getDepartmentId, 0L)
                    .set(Inventory::getQuantity, quantity)
            );
            if (!update) {
                System.err.println(code + " 0库存");
            }

            boolean update1 = inOutStorageDetailsService.update(q -> q
                    .eq(InOutStorageDetails::getBomSpecId, bomSpecId)
                    .eq(InOutStorageDetails::getWarehouseId, 1684037244354052098L)
                    .eq(InOutStorageDetails::getDepartmentId, 0L)
                    .set(InOutStorageDetails::getQuantity, quantity)
            );
            if (!update1) {
                System.err.println(code + " 0结存");
            }

        }


    }


}
